unit LifeUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Math, ZLib, ExtDlgs;

type
  T8Bools = array[0..7] of Boolean;

  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    ScrollBar1: TScrollBar;
    MainMenu1: TMainMenu;
    file1: TMenuItem;
    Exit1: TMenuItem;
    New1: TMenuItem;
    Random1: TMenuItem;
    Glider1: TMenuItem;
    Pentominoe1: TMenuItem;
    Clear1: TMenuItem;
    RandomGliders1: TMenuItem;
    Button2: TButton;
    Fish1: TMenuItem;
    N1: TMenuItem;
    SaveState1: TMenuItem;
    SaveDialog1: TSaveDialog;
    LoadState1: TMenuItem;
    OpenDialog1: TOpenDialog;
    N2: TMenuItem;
    LoadFromBitmap1: TMenuItem;
    SaveAsBitmap1: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Random1Click(Sender: TObject);
    procedure Pentominoe1Click(Sender: TObject);
    procedure Glider1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    function  Globe(x : integer) : integer;
    procedure RandomGliders1Click(Sender: TObject);
    procedure CreateGlider(x : integer ; y : integer ; orientation : integer);
    procedure Button2Click(Sender: TObject);
    procedure Draw(x: integer; y: integer);
    procedure Fish1Click(Sender: TObject);
//    procedure horrendous1Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SaveState1Click(Sender: TObject);
    procedure LoadState1Click(Sender: TObject);
    procedure SaveAsBitmap1Click(Sender: TObject);
    procedure LoadFromBitmap1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function PackBools(bools : T8Bools) : byte;
function UnPackBools(AByte : byte) : T8Bools;
procedure PackStream(inStream, outStream :TStream;
                     CompressionLevel:TCompressionLevel);
procedure ExpandStream(inStream, outStream :TStream);

var
  Form1: TForm1;
  oldS, newS : array[0..200,0..200] of byte;
  Step : boolean;
  Bitmap : TBitmap;
  Scanlines : array[0..200] of pByteArray;
  RGBWhite, RGBBlack : byte;
  MainRect, ScreenRect : TRect;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
Var
  x, y : integer;
begin
  Step := False;
  randomize;

  MainRect := Rect(0,0,201,201);
  ScreenRect := Rect(0,0,402,402);

  Bitmap := TBitmap.Create;
  Bitmap.PixelFormat := pf8bit;
  Bitmap.Width := 201;
  Bitmap.Height := 201;

  Bitmap.Canvas.FillRect(MainRect);
  for y := 0 to 200 do Scanlines[y] := Bitmap.ScanLine[y];

  for y := 0 to 200 do begin
    for x := 0 to 200 do begin
      oldS[x,y] := 0;
      newS[x,y] := 0;
      if round(random(10)) = 1 then Draw(x,y);
    end;
  end;

  RGBWhite := 255;
  RGBBlack := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if button1.caption = 'START' then begin
    button1.caption := 'STOP';
    timer1.enabled := true;
    New1.Enabled := False;
    button2.Enabled := False;
    LoadState1.Enabled := False;
    SaveState1.Enabled := False;
    LoadFromBitmap1.Enabled := False;
    SaveAsBitmap1.Enabled := False;
  end else begin
    button1.caption := 'START';
    timer1.enabled := False;
    New1.Enabled := True;
    button2.Enabled := True;
    LoadState1.Enabled := True;
    SaveState1.Enabled := True;
    LoadFromBitmap1.Enabled := True;
    SaveAsBitmap1.Enabled := True;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Var
  x, y, NeighSum : integer;
begin
  for y := 0 to 200 do for x := 0 to 200 do begin
    NeighSum := oldS[Globe(x-1),Globe(y-1)]+oldS[x,Globe(y-1)]+
                oldS[Globe(x+1),Globe(y-1)]+oldS[Globe(x-1),y]+
                oldS[Globe(x+1),y]+oldS[Globe(x-1),Globe(y+1)]+
                oldS[x,Globe(y+1)]+oldS[Globe(x+1),Globe(y+1)];

    if (NeighSum = 3)and(oldS[x,y] <> 1) then begin
      newS[x,y] := 1;
      Scanlines[y][x] := RGBBlack;
    end else
    if ((NeighSum < 2)or(NeighSum > 3))and(oldS[x,y] <> 0) then begin
      newS[x,y] := 0;
      Scanlines[y][x] := RGBWhite;
    end;
  end;

  oldS := newS;

  Canvas.StretchDraw(ScreenRect,Bitmap);

  if Step then begin
    Timer1.Enabled := False;
    Step := False;
  end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  timer1.Interval := scrollbar1.position;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Random1Click(Sender: TObject);
Var
  x, y : integer;
begin
  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  for y := 0 to 200 do for x := 0 to 200 do begin
    if round(random(10)) = 1 then
      Draw(x,y)
    else begin
      oldS[x,y] := 0;
      news[x,y] := 0;
    end;
  end;

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

procedure TForm1.Pentominoe1Click(Sender: TObject);
Var
  x, y : integer;
begin
  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  for y := 0 to 200 do for x := 0 to 200 do begin
    oldS[x,y] := 0;
    newS[x,y] := 0;
  end;

  Draw(100,100);
  Draw(101,100);
  Draw(101,101);
  Draw(101,99);
  Draw(102,99);

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

procedure TForm1.Glider1Click(Sender: TObject);
Var
  x, y : integer;
begin
  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  for y := 0 to 200 do for x := 0 to 200 do begin
    oldS[x,y] := 0;
    newS[x,y] := 0;
  end;

  CreateGlider(100,100,Random(4)+1);

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

procedure TForm1.Clear1Click(Sender: TObject);
Var
  x, y : integer;
begin
  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  for y := 0 to 200 do for x := 0 to 200 do begin
    oldS[x,y] := 0;
    newS[x,y] := 0;
  end;

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

function TForm1.Globe(x : integer) : integer;
begin
  Result := x;
  if x < 0 then Result := 200 else
  if x > 200 then Result := 0;
end;

procedure TForm1.RandomGliders1Click(Sender: TObject);
Var
  x, y, population : integer;
begin
  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  for y := 0 to 200 do for x := 0 to 200 do begin
    oldS[x,y] := 0;
    newS[x,y] := 0;
  end;

  for population := 1 to 50 do
    CreateGlider(Random(194)+2,Random(194)+2,Random(4)+1);

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

procedure TForm1.CreateGlider(x : integer ;y : integer ;orientation : integer);
Var
  XDir, YDir : ShortInt;
begin
  XDir := 1; YDir := 1;
  if orientation = 1 then begin XDir := -1; YDir := 1; end;
  if orientation = 2 then begin XDir := 1; YDir := -1; end;
  if orientation = 3 then begin XDir := -1; YDir := -1; end;
  Draw(x,y);
  Draw(x+XDir,y);
  Draw(x+XDir*2,y);
  Draw(x+XDir*2,y+YDir);
  Draw(x+XDir,y+YDir*2);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Timer1.Enabled := True;
  Step := True;
end;

procedure TForm1.Draw(x: integer; y: integer);
begin
  Scanlines[y][x] := RGBBlack;
  oldS[x,y] := 1;
  newS[x,y] := 1;
end;

procedure TForm1.Fish1Click(Sender: TObject);
Var
 x, y : integer;
begin
  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  for y := 0 to 200 do for x := 0 to 200 do begin
    oldS[x,y] := 0;
    newS[x,y] := 0;
  end;

  Draw(100,100);
  Draw(101,99);
  Draw(102,99);
  Draw(103,99);
  Draw(104,99);
  Draw(104,100);
  Draw(104,101);
  Draw(103,102);
  Draw(100,102);

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

{procedure TForm1.horrendous1Click(Sender: TObject);
Var
 x, y : integer;
begin
  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  for y := 0 to 200 do for x := 0 to 200 do begin
    oldS[x,y] := 0;
    newS[x,y] := 0;
  end;

  CreateGlider(50,50,2);
  CreateGlider(150,50,3);
  CreateGlider(50,148,4);
  CreateGlider(150,148,1);

  Draw(0,100); Draw(1,99); Draw(2,99); Draw(3,99); Draw(4,99);
  Draw(4,100); Draw(4,101); Draw(3,102); Draw(0,102);

  Draw(199,100); Draw(198,99); Draw(197,99); Draw(196,99); Draw(195,99);
  Draw(195,100); Draw(195,101); Draw(196,102); Draw(199,102);

  Draw(98,3); Draw(99,4); Draw(100,4); Draw(101,4); Draw(101,3);
  Draw(101,2); Draw(101,1); Draw(100,0); Draw(98,0);

  Draw(98,196); Draw(99,195); Draw(100,195); Draw(101,195); Draw(101,196);
  Draw(101,197); Draw(101,198); Draw(100,199); Draw(98,199);

  Draw(98,98); Draw(98,99); Draw(98,100); Draw(98,101); Draw(98,102);
  Draw(102,98); Draw(102,99); Draw(102,100); Draw(102,101); Draw(102,102);
  Draw(100,98); Draw(100,102);

  Canvas.StretchDraw(ScreenRect,Bitmap);
end; }

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
  LX, LY : integer;
  LScale : Single;
begin
  LScale := 200 / ScreenRect.Right;
  LX := Round(X*LScale);
  LY := Round(Y*LScale);

  if (LX > 200) or (LY > 200) then Exit;

  if Scanlines[LY][LX] = 255 then begin
    Draw(LX, LY);
  end else
  if Scanlines[LY][LX] = 0 then begin
    Scanlines[LY][LX] := RGBWhite;
    oldS[LX,LY] := 0;
    newS[LX,LY] := 0;
  end;

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

procedure TForm1.FormResize(Sender: TObject);
Var
  Lmin : integer;
begin
  Lmin := min(ClientWidth - 34,ClientHeight - 37);
  if Lmin < ScreenRect.Right then begin
    Canvas.Brush.Color := clBtnFace;
    Canvas.FillRect(ClientRect);
  end;
  ScreenRect := Rect(0,0,Lmin,Lmin);
  Button1.Top := Lmin + 8;
  Button2.Top := Lmin + 8;
  ScrollBar1.Left := Lmin + 13;
  Canvas.StretchDraw(ScreenRect,Bitmap);
end;                           

procedure TForm1.SaveState1Click(Sender: TObject);
Var
  x, y, b, LByte : byte;
  i : integer;
  LBools : T8Bools;
  LStream, LStreamPacked : TMemoryStream;
begin
  if not SaveDialog1.Execute then Exit;

  LStream := TMemoryStream.Create;
  LStream.Seek(0,0);

  x := 0; y := 0;
  b := 0;
  for i := 0 to 201*201 - 1 do begin
    if NewS[x,y] = 1 then LBools[b] := True
                     else LBools[b] := False;

    Inc(b);
    if b > 7 then begin
      b := 0;
      LByte := PackBools(LBools);
      LStream.Write(LByte,1);
    end;

    Inc(x);
    if x > 200 then begin
      x := 0;
      Inc(y);
    end;
  end;

  if b > 0 then begin
    for i := b to 7 do LBools[i] := False;
    LByte := PackBools(LBools);
    LStream.Write(LByte,1);
  end;

  LStreamPacked := TMemoryStream.Create;
  PackStream(LStream, LStreamPacked, clMax);
  LStreamPacked.SaveToFile(SaveDialog1.FileName);
  LStream.Free;
  LStreamPacked.Free;
end;

procedure TForm1.LoadState1Click(Sender: TObject);
Var
  x, y, b, LByte : byte;
  i : integer;
  LBools : T8Bools;
  LStream, LStreamPacked : TMemoryStream;
begin
  if not OpenDialog1.Execute then Exit;

  Bitmap.Canvas.Brush.Color := clwhite;
  Bitmap.Canvas.FillRect(MainRect);

  LStreamPacked := TMemoryStream.Create;
  LStreamPacked.LoadFromFile(OpenDialog1.FileName);
  LStream := TMemoryStream.Create;
  ExpandStream(LStreamPacked, LStream);
  LStreamPacked.Free;
  LStream.Seek(0, 0);

  x := 0; y := 0;
  b := 0;
  LStream.Read(LByte, 1);
  LBools := UnPackBools(LByte);
  for i := 0 to 201*201 - 1 do begin
    if LBools[b] then Draw(x,y) else NewS[x,y] := 0;

    Inc(b);
    if b > 7 then begin
      b := 0;
      LStream.Read(LByte, 1);
      LBools := UnPackBools(LByte);
    end;

    Inc(x);
    if x > 200 then begin
      x := 0;
      Inc(y);
    end;
  end;

  LStream.Free;

  OldS := NewS;
  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

function PackBools(bools : T8Bools) : byte;
Var
  i, p : byte;
begin
  Result := 0;
  p := 128;
  for i := 0 to 7 do begin
    if bools[i] then Inc(Result, p);
    p := p div 2;
  end;
end;

function UnPackBools(AByte : byte) : T8Bools;
Var
  i, p : byte;
begin
  p := 128;
  for i := 0 to 7 do begin
    if AByte >= p then begin
      Result[i] := True;
      Dec(AByte, p);
    end else Result[i] := False;
    p := p div 2;
  end;
end;

procedure PackStream(inStream, outStream :TStream;
                     CompressionLevel:TCompressionLevel);
var ZStream: TCompressionStream; 
begin 
    ZStream := TCompressionStream.Create(CompressionLevel, OutStream); 
  try 
    ZStream.CopyFrom(InStream, 0); 
  finally 
    ZStream.Free; 
  end; 
end; 

procedure ExpandStream(inStream, outStream :TStream);
const 
  BufferSize = 4096; 
var 
  Count: Integer; 
  ZStream: TDecompressionStream; 
  Buffer: array[0..BufferSize-1] of Byte; 
begin 
  ZStream := TDecompressionStream.Create(InStream); 
  try 
    while True do 
      begin 
        Count := ZStream.Read(Buffer, BufferSize); 
        if Count <> 0 then OutStream.WriteBuffer(Buffer, Count) else Break; 
      end; 
  finally 
    ZStream.Free; 
  end; 
end;

procedure TForm1.SaveAsBitmap1Click(Sender: TObject);
Var
  LBitmap : TBitmap;
begin
  if not SavePictureDialog1.Execute then Exit;

  LBitmap := TBitmap.Create;
  LBitmap.PixelFormat := pf1bit;
  LBitmap.Width := 201;
  LBitmap.Height := 201;
  LBitmap.Canvas.Draw(0, 0, Bitmap);

  LBitmap.SaveToFile(SavePictureDialog1.FileName);
  LBitmap.Free;
end;

procedure TForm1.LoadFromBitmap1Click(Sender: TObject);
Var
  LBitmap : TBitmap;
  x, y : integer;
begin
  if not OpenPictureDialog1.Execute then Exit;

  LBitmap := TBitmap.Create;
  LBitmap.LoadFromFile(OpenPictureDialog1.FileName);
  LBitmap.PixelFormat := pf1bit;
  LBitmap.Width := 201;
  LBitmap.Height := 201;
  Bitmap.Canvas.Draw(0, 0, LBitmap);
  LBitmap.Free;

  for y := 0 to 200 do begin
    for x := 0 to 200 do begin
      if Scanlines[y][x] = 0 then NewS[x,y] := 1 else begin
        NewS[x,y] := 0;
        Scanlines[y][x] := 255;
      end;
    end;
  end;
  OldS := NewS;

  Canvas.StretchDraw(ScreenRect,Bitmap);
end;

end.
